ad_page_contract {
    Drop a dynamic object-type
} {
    object_type:sql_identifier,notnull
}

set user_id [auth::require_login]
permission::require_permission -object_id [ad_conn package_id] -privilege admin

acs_object_type::get -object_type $object_type -array dtype

ad_form -name delete -export {object_type} -cancel_url . -form {
    {notice:text(inform) {label "Delete object_type ${dtype(pretty_name)}? All data collected for this object type will be lost."}}
} -on_submit {
    # delete objects
    db_foreach object_ids "select ${dtype(id_column)} as o_id from ${dtype(table_name)}" {
        db_0or1row delete "select acs_object__delete(:o_id)"
    }
    
    # drop forms
    db_foreach form_ids "select form_id from dtype_form_type_map where object_type=:object_type" {
        dtype::form::unmap_type -form_id $form_id -object_type $object_type
        db_foreach element_ids "select element_id from dtype_elements where form_id = :form_id" {
            db_dml unmap "delete from dtype_element_attribute_map where element_id=:element_id"
        }
        
        # automatically drops elements
        dtype::form::delete -form_id $form_id
    }
    
    dtype::delete -name $object_type -drop_children -drop_table

    ad_returnredirect -message "Deleted object type $object_type" .
}