ad_page_contract {

    @author Timo Hentschel (timo@timohentschel.de)
    @creation-date 2005-06-03
    @cvs-id $Id: element.tcl,v 1.2 2005/12/23 17:33:33 dblue Exp $

} {
    {form_id:notnull}
    {object_type:notnull}
    element_id:optional
}

set user_id [auth::require_login]
permission::require_permission -object_id [ad_conn package_id] -privilege admin

acs_object_type::get -object_type $object_type -array type_info
db_1row get_form_name {}

set page_title "[_ dynamic-types.add_element]"
set context [list [list [export_vars -base dtype {object_type}] $type_info(pretty_name)] [list [export_vars -base form {object_type form_id}] "[_ dynamic-types.form_one]"] $page_title]

if {[ad_form_new_p -key element_id]} {
    set attribute_options [db_list_of_lists get_attributes {}]
} else {
    dtype::element::get -element_id $element_id -array element
    set attribute_id [db_string get_attr_id "select attribute_id from dtype_element_attribute_map where element_id=:element_id"]
    set pretty_name [db_string get_attr_name "select attribute_name from acs_attributes where attribute_id = :attribute_id"]
    set attribute_options [list [list $pretty_name $attribute_id]]
    set widget $element(widget)
}

set boolean_options [list [list "[_ acs-kernel.common_Yes]" 1] [list "[_ acs-kernel.common_no]" 0]]
set widget_options [concat [db_list_of_lists get_widgets {}]]

ad_form -name element_form -export {object_type form_id} -form {
    {element_id:key}
    {attribute_id:text(select) {label "[_ dynamic-types.attribute_name]"} {options $attribute_options} {help_text "[_ dynamic-types.element_name_help]"}}
    {widget:text(select) {label "[_ dynamic-types.widget]"} {options $widget_options} {help_text "[_ dynamic-types.widget_help]"}}
} -edit_request {
} -new_data {
    set attribute_name [db_string attr_name "select attribute_name from acs_attributes where attribute_id=:attribute_id"]
    set element_id [dtype::form::add_element -form_id $form_id -element $attribute_name -widget $widget]
    dtype::element::map_attribute -element_id $element_id -attribute_id $attribute_id
} -edit_data {
    # update widget
    db_dml update_widget "update dtype_elements set widget = :widget where element_id = :element_id"
    
    # delete previous attribute mapping
    db_1row get_old_attr "select attribute_id as old_attr_id from dtype_element_attribute_map where element_id=:element_id"
    dtype::element::unmap_attribute -element_id $element_id -attribute_id $old_attr_id

    # remap to new attribute
    dtype::element::map_attribute -element_id $element_id -attribute_id $attribute_id
} -after_submit {
    ad_returnredirect [export_vars -base form {object_type form_id}]
    ad_script_abort
}

ad_return_template
